力扣第39天----第198题、第213题、第337题

力扣第39天----第198题、第213题、第337题

文章目录

一、第198题--打家劫舍

​ 经过前面背包题目的训练,这题挺简单,没啥太多可说的。递推公式,考虑当前点是否采用,分采用、不采用2种思路进行。

c++ 复制代码
class Solution {
public:
    int rob(vector<int>& nums) {
        vector<int> dp(nums.size(), 0);
        dp[0] = nums[0];
        if (nums.size() <2) return nums[0];
        dp[1] = max(nums[0], nums[1]);
        for (int i = 2; i< nums.size(); ++i){
            dp[i] = max(dp[i-1], dp[i-2] + nums[i]);
        }
        return dp[nums.size() - 1];
    }
};

二、第213题--打家劫舍II

​ 环形问题,展开成线性问题,展开成2种线性结构,再分别考虑。

c++ 复制代码
class Solution {
public:
    int rob_linear(vector<int>& nums) {
        vector<int> dp(nums.size(), 0);
        dp[0] = nums[0];
        if (nums.size() <2) return nums[0];
        dp[1] = max(nums[0], nums[1]);
        for (int i = 2; i< nums.size(); ++i){
            dp[i] = max(dp[i-1], dp[i-2] + nums[i]);
        }
        return dp[nums.size() - 1];
    }

    int rob(vector<int>& nums) {
        if (nums.size() == 1) return nums[0];
        vector<int> nums10(nums.begin(), nums.end()-1);
        int line10 = rob_linear(nums10);

        vector<int> nums01(nums.begin()+1, nums.end());
        int line01 = rob_linear(nums01);
        return max(line01, line10);
    }
};

三、第337题--打家劫舍 III

​ 树形dp----没基础的话,不太好做;跟着做下来,基本消化了吧。

​ dp数组----每个节点不采用、采用状态下,得到的金钱;所以,就是个二维数组。

​ 遍历顺序----采用树的遍历方式,这里采用后序遍历。子节点处理完了,才能处理根节点。

​ 初始化----这里与截止条件重合,树遍历终止的时候,就是dp数组初始化的时候,初始化为{0,0},即空节点时价值为0。

​ 递推公式----分采用当前节点、不采用当前节点2种情况分别递推。采用的时候,下一层就不能采用,就是left0、right0,然后再加起来;不采用的时候,下一层就要综合考虑,所以max(left0, left1)、max(right0, right1),左右分支都要考虑到,再加一起。

c++ 复制代码
class Solution {
public:
    int rob(TreeNode* root) {
        vector<int> result = robTree(root);
        return max(result[0], result[1]);
    }
    vector<int> robTree(TreeNode* root){    //0表示不采取当前点,1表示采取当前点。
        if (root == nullptr) return vector<int> {0,0};
        vector<int> left = robTree(root->left);
        vector<int> right = robTree(root->right);

        int cur_get = root->val + left[0] + right[0];
        int cur_noget = max(left[0], left[1]) + max(right[0], right[1]);
        return vector<int> {cur_noget, cur_get};
    }
};
相关推荐
罗湖老棍子6 小时前
【例 1】Sightseeing Trip(信息学奥赛一本通- P1494)(洛谷-P10927)
数据结构·算法·图论·最短路·floyd·最小环
文丑颜不良啊6 小时前
LeetCode201~225题目解析
java·leetcode
stsdddd8 小时前
YOLO算法建筑工地安全帽目标检测数据集16881张:标注核对笔记
算法·yolo·目标检测
CV爱数码9 小时前
论文精读|Learned Primal-Dual:把原始–对偶算法展开成网络
图像处理·算法·计算机视觉·ct·重建·断层扫描
yuniko-n9 小时前
【算法】约瑟夫环问题
java·算法
l1t10 小时前
测试DuckDB v2.1.0-alpha49002的bignum乘法
数据库·sql·算法·duckdb
Nil20810 小时前
LeetCode 283移动零
数据结构·算法·leetcode
CQU_JIAKE10 小时前
10.18【A】
算法
学顶教育10 小时前
学顶教育:公务员面试常见问题!
面试·职场和发展
LMT流氓兔10 小时前
第五单元——第4课:给工具参数加校验
java·前端·算法·ai·langchain